VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsESMTP"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source!

'////////////////////////////////////////////////////////////////////////////////////////////////////
'//                                                                                                //
'// ESMTP Class - coded by madmax/UD                                                               //
'// --------------------------------                                                               //
'//                                                                                                //
'// MAIL: c.madmax@gmx.li                                                                          //
'// DATE: 7/7/03                                                                                   //
'// LAST UPDATE: 30/03/05                                                                                                //
'////////////////////////////////////////////////////////////////////////////////////////////////////
Option Explicit
'----------------------------------------------------------------------------------------------------
'-----[ Event's ]------------------------------------------------------------------------------------
Public Event LogData(Sender As String, Data As String)
Public Event SendComplete()
Public Event Error(Description As String)
Public Event SendFileProgress(Percent As Single, FileIndex As Long, FileCount As Long)
'----------------------------------------------------------------------------------------------------
'-----[ Constants ]----------------------------------------------------------------------------------
Private Const APPLICATION_NAME              As String = "ESMTP Class by madmax V1.0"
Private Const BASE64_TABLE                  As String = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"
Private Const MS_ENHANCED_PROV              As String = "Microsoft Enhanced Cryptographic Provider v1.0"
Private Const CRYPT_VERIFYCONTEXT           As Long = &HF0000000
Private Const PROV_RSA_FULL                 As Long = &H1&
Private Const HP_HASHVAL                    As Long = &H2&
Private Const HP_HASHSIZE                   As Long = &H4&
Private Const CALG_MD5                      As Long = &H8003&
Private Const INVALID_HANDLE_VALUE          As Long = &HFFFFFFFF
Private Const FILE_ATTRIBUTE_DIRECTORY      As Long = &H10&
Private Const LNG_BUFFER_SIZE               As Long = &H600&
Private Const LNG_LINE_SIZE                 As Long = &H4C&
'----------------------------------------------------------------------------------------------------
Private Const LNG_ENCODING_NONE             As Long = &H0&
Private Const LNG_ENCODING_7BIT             As Long = &H1&
Private Const LNG_ENCODING_QUOTED_PRINTABLE As Long = &H2&
Private Const LNG_ENCODING_BASE64           As Long = &H3&
Private Const LNG_ENCODING_8BIT             As Long = &H4&
Private Const LNG_ENCODING_BINARY           As Long = &H5&
'----------------------------------------------------------------------------------------------------
Private Const TIME_ZONE_ID_INVALID As Long = &HFFFFFFFF
'----------------------------------------------------------------------------------------------------
'-----[ Types ]--------------------------------------------------------------------------------------
Private Type MAIL_RECEIVER
    strName As String
    strAddr As String
End Type
'----------------------------------------------------------------------------------------------------
Private Type MAIL_HEADER
    strKey As String
    strVal As String
End Type
'----------------------------------------------------------------------------------------------------
Private Type MAIL_ATTACHMENT
    strDesc As String
    strPath As String
End Type
'----------------------------------------------------------------------------------------------------
Private Type SYSTEMTIME
        wYear As Integer
        wMonth As Integer
        wDayOfWeek As Integer
        wDay As Integer
        wHour As Integer
        wMinute As Integer
        wSecond As Integer
        wMilliseconds As Integer
End Type
Private Type TIME_ZONE_INFORMATION
        Bias As Long
        StandardName(32) As Integer
        StandardDate As SYSTEMTIME
        StandardBias As Long
        DaylightName(32) As Integer
        DaylightDate As SYSTEMTIME
        DaylightBias As Long
End Type
'----------------------------------------------------------------------------------------------------
'-----[ APIs ]---------------------------------------------------------------------------------------
Private Declare Function CryptAcquireContext Lib "advapi32.dll" Alias "CryptAcquireContextA" (phProv As Long, ByVal pszContainer As String, ByVal pszProvider As String, ByVal dwProvType As Long, ByVal dwFlags As Long) As Long
Private Declare Function CryptCreateHash Lib "advapi32.dll" (ByVal hProv As Long, ByVal Algid As Long, ByVal hKey As Long, ByVal dwFlags As Long, phHash As Long) As Long
Private Declare Function CryptHashData Lib "advapi32.dll" (ByVal hHash As Long, ByVal pbData As String, ByVal dwDataLen As Long, ByVal dwFlags As Long) As Long
Private Declare Function CryptDestroyHash Lib "advapi32.dll" (ByVal hHash As Long) As Long
Private Declare Function CryptReleaseContext Lib "advapi32.dll" (ByVal hProv As Long, ByVal dwFlags As Long) As Long
Private Declare Function CryptGetHashParam Lib "advapi32.dll" (ByVal pCryptHash As Long, ByVal dwParam As Long, ByRef pbData As Any, ByRef pcbData As Long, ByVal dwFlags As Long) As Long
'----------------------------------------------------------------------------------------------------
Private Declare Function GetFileAttributes Lib "kernel32" Alias "GetFileAttributesA" (ByVal lpFileName As String) As Long
'----------------------------------------------------------------------------------------------------
Private Declare Function GetTimeZoneInformation Lib "kernel32" _
    (lpTimeZoneInformation As TIME_ZONE_INFORMATION) As Long
'----------------------------------------------------------------------------------------------------
'-----[ Enums ]--------------------------------------------------------------------------------------
Public Enum MAIL_TYPE
    TextMail
    HTMLMail
    Both
End Enum
'----------------------------------------------------------------------------------------------------
Public Enum SMTP_AUTH_TYPE
    AUTH_POP3_BEFORE_SMTP
    AUTH_PLAIN
    AUTH_LOGIN
    AUTH_CRAM_MD5
End Enum
'----------------------------------------------------------------------------------------------------
Public Enum SMTP_MESSAGE_ENCODING
    smUsAscii7Bit = LNG_ENCODING_7BIT
    smQuotedPrintable = LNG_ENCODING_QUOTED_PRINTABLE
    smBase64 = LNG_ENCODING_BASE64
    smMime8Bit = LNG_ENCODING_8BIT
    smBinary = LNG_ENCODING_BINARY
End Enum
'----------------------------------------------------------------------------------------------------
Public Enum SMTP_FILE_ENCODING
    sfBase64 = LNG_ENCODING_BASE64
End Enum
'----------------------------------------------------------------------------------------------------
Public Enum SMTP_HEADER_ENCODING
    shNone = LNG_ENCODING_NONE
    shQuotedPrintable = LNG_ENCODING_QUOTED_PRINTABLE
    shBase64 = LNG_ENCODING_BASE64
End Enum
'----------------------------------------------------------------------------------------------------
Private Enum SEND_MAIL_STATE
    stCancel = (-3)
    stTimeout = (-2)
    stError = (-1)
    stNothing
    stDisconnected
    stConnected
    stEhlo
    stRequestAuthentication
    stUsername
    stPassword
    stPopLogin 'stList
    stMailFrom
    stRcptTo
    stData
    stQuit
    stComplete
End Enum
'----------------------------------------------------------------------------------------------------
'-----[ Objects ]-------------------------------------------------------|----------------------------
Private WithEvents sckSMTP                  As MSWinsockLib.Winsock     'Winsock
Attribute sckSMTP.VB_VarHelpID = -1
Private WithEvents sckPOP3                  As MSWinsockLib.Winsock     'Winsock
Attribute sckPOP3.VB_VarHelpID = -1
Private WithEvents tmrTime                  As VB.Timer                 'Timer
Attribute tmrTime.VB_VarHelpID = -1
'-----[ Intern Variables ]----------------------------------------------|----------------------------
'-----------------------------------------------------------------------|----------------------------
Private objMailReceiverCC()                 As MAIL_RECEIVER            'Intern
Private lngMailReceiverCC                   As Long                     'Intern
'-----------------------------------------------------------------------|----------------------------
Private objMailReceiverBCC()                As MAIL_RECEIVER            'Intern
Private lngMailReceiverBCC                  As Long                     'Intern
'-----------------------------------------------------------------------|----------------------------
Private strMailBoundary                     As String                   'Intern
Private objMailAttachment()                 As MAIL_ATTACHMENT          'Intern
Private lngMailAttachment                   As Long                     'Intern
Private intMailAttachment                   As Integer                  'Intern
'-----------------------------------------------------------------------|----------------------------
Private sngSendFilePercent                  As Single                   'Intern
Private lngSendFileIndex                    As Long                     'Intern
Private lngSendFileCount                    As Long                     'Intern
'-----------------------------------------------------------------------|----------------------------
Private objMailHeader()                     As MAIL_HEADER              'Intern
Private lngMailHeader                       As Long                     'Intern
'-----------------------------------------------------------------------|----------------------------
Private lngSendMailState                    As SEND_MAIL_STATE          'Intern
'-----------------------------------------------------------------------|----------------------------
Private dblByteLoad                         As Double                   'Intern
Private dblByteSend                         As Double                   'Intern
'-----------------------------------------------------------------------|----------------------------
Private dblLastData                         As Double                   'Intern
'-----------------------------------------------------------------------|----------------------------
Private blnServerDisconnect                 As Boolean                  'Intern
'----------------------------------------------------------------------------------------------------
'-----[ Property Variables ]--------------------------------------------|----------------------------
Private strAccountUsername                  As String                   'Property
Private strAccountPassword                  As String                   'Property
'-----------------------------------------------------------------------|----------------------------
Private lngAuthentication                   As SMTP_AUTH_TYPE           'Property
'-----------------------------------------------------------------------|----------------------------
Private lngMailMessageEncoding              As SMTP_MESSAGE_ENCODING    'Property
Private lngMailFileEncoding                 As SMTP_FILE_ENCODING       'Property
Private lngMailHeaderEncoding               As SMTP_HEADER_ENCODING     'Property
'-----------------------------------------------------------------------|----------------------------
Private lngTimeout                          As Long                     'Property
'-----------------------------------------------------------------------|----------------------------
Private strServerNamePOP3                   As String                   'Property
Private lngServerPortPOP3                   As Long                     'Property
'-----------------------------------------------------------------------|----------------------------
Private strServerNameSMTP                   As String                   'Property
Private lngServerPortSMTP                   As Long                     'Property
'-----------------------------------------------------------------------|----------------------------
Private strMailFromName                     As String                   'Property
Private strMailFromAddress                  As String                   'Property
Private strMailReceiverName                 As String                   'Property
Private strMailReceiverAddress              As String                   'Property
Private strMailCC                           As String                   'Property
Private strMailBCC                          As String                   'Property
Private strMailSubject                      As String                   'Property
Private strMailMessageText                  As String                   'Property
Private strMailMessageHTML                  As String                   'Property
Private lngMailType                         As MAIL_TYPE                'Property
'====================================================================================================
'-----[ Property Account Username ]------------------------------------------------------------------
Public Property Get AccountUsername() As String
    AccountUsername = strAccountUsername
End Property
Public Property Let AccountUsername(strNewAccountUsername As String)
    strAccountUsername = strNewAccountUsername
End Property
'----------------------------------------------------------------------------------------------------
'-----[ Property Account Password ]------------------------------------------------------------------
Public Property Get AccountPassword() As String
    AccountPassword = strAccountPassword
End Property
Public Property Let AccountPassword(strNewAccountPassword As String)
    strAccountPassword = strNewAccountPassword
End Property
'----------------------------------------------------------------------------------------------------
'-----[ Property SMTP Auth ]-------------------------------------------------------------------------
Public Property Get Authentication() As SMTP_AUTH_TYPE
    Authentication = lngAuthentication
End Property
Public Property Let Authentication(lngNewAuthentication As SMTP_AUTH_TYPE)
    lngAuthentication = lngNewAuthentication
End Property
'----------------------------------------------------------------------------------------------------
'-----[ Property Mail Type ]-------------------------------------------------------------------------
Public Property Get MailType() As MAIL_TYPE
    MailType = lngMailType
End Property
Public Property Let MailType(lngNewMailType As MAIL_TYPE)
    lngMailType = lngNewMailType
End Property
'----------------------------------------------------------------------------------------------------
'-----[ Property Mail Encoding ]---------------------------------------------------------------------
Public Property Get MailMessageEncoding() As SMTP_MESSAGE_ENCODING
    MailMessageEncoding = lngMailMessageEncoding
End Property
Public Property Let MailMessageEncoding(lngNewMailMessageEncoding As SMTP_MESSAGE_ENCODING)
    lngMailMessageEncoding = lngNewMailMessageEncoding
End Property
'----------------------------------------------------------------------------------------------------
'-----[ Property File Encoding ]---------------------------------------------------------------------
Public Property Get MailFileEncoding() As SMTP_FILE_ENCODING
    MailFileEncoding = lngMailFileEncoding
End Property
Public Property Let MailFileEncoding(lngNewMailFileEncoding As SMTP_FILE_ENCODING)
    lngMailFileEncoding = lngNewMailFileEncoding
End Property
'----------------------------------------------------------------------------------------------------
'-----[ Property Header Encoding ]-------------------------------------------------------------------
Public Property Get MailHeaderEncoding() As SMTP_HEADER_ENCODING
    MailHeaderEncoding = lngMailHeaderEncoding
End Property
Public Property Let MailHeaderEncoding(lngNewMailHeaderEncoding As SMTP_HEADER_ENCODING)
    lngMailHeaderEncoding = lngNewMailHeaderEncoding
End Property
'----------------------------------------------------------------------------------------------------
'-----[ Property Server Name POP3 ]------------------------------------------------------------------
Public Property Get ServerNamePOP3() As String
    ServerNamePOP3 = strServerNamePOP3
End Property
Public Property Let ServerNamePOP3(strNewServerNamePOP3 As String)
    strServerNamePOP3 = strNewServerNamePOP3
End Property
'----------------------------------------------------------------------------------------------------
'-----[ Property Server Port POP3 ]------------------------------------------------------------------
Public Property Get ServerPortPOP3() As Long
    ServerPortPOP3 = lngServerPortPOP3
End Property
Public Property Let ServerPortPOP3(lngNewServerPortPOP3 As Long)
    lngServerPortPOP3 = lngNewServerPortPOP3
End Property
'----------------------------------------------------------------------------------------------------
'-----[ Property Server Name SMTP ]------------------------------------------------------------------
Public Property Get ServerNameSMTP() As String
    ServerNameSMTP = strServerNameSMTP
End Property
Public Property Let ServerNameSMTP(strNewServerNameSMTP As String)
    strServerNameSMTP = strNewServerNameSMTP
End Property
'----------------------------------------------------------------------------------------------------
'-----[ Property Server Port SMTP ]------------------------------------------------------------------
Public Property Get ServerPortSMTP() As Long
    ServerPortSMTP = lngServerPortSMTP
End Property
Public Property Let ServerPortSMTP(lngNewServerPortSMTP As Long)
    lngServerPortSMTP = lngNewServerPortSMTP
End Property
'----------------------------------------------------------------------------------------------------
'-----[ Property Timeout ]---------------------------------------------------------------------------
Public Property Get Timeout() As Long
    Timeout = lngTimeout
End Property
Public Property Let Timeout(lngNewTimeout As Long)
    lngTimeout = lngNewTimeout
End Property
'----------------------------------------------------------------------------------------------------
'-----[ Property Mail From Name ]--------------------------------------------------------------------
Public Property Get MailFromName() As String
    MailFromName = strMailFromName
End Property
Public Property Let MailFromName(strNewMailFromName As String)
    strMailFromName = strNewMailFromName
End Property
'----------------------------------------------------------------------------------------------------
'-----[ Property Mail From Address ]-----------------------------------------------------------------
Public Property Get MailFromAddress() As String
    MailFromAddress = strMailFromAddress
End Property
Public Property Let MailFromAddress(strNewMailFromAddress As String)
    strMailFromAddress = strNewMailFromAddress
End Property
'----------------------------------------------------------------------------------------------------
'-----[ Property Mail Receiver Name ]----------------------------------------------------------------
Public Property Get MailReceiverName() As String
    MailReceiverName = strMailReceiverName
End Property
Public Property Let MailReceiverName(strNewMailReceiverName As String)
    strMailReceiverName = strNewMailReceiverName
End Property
'----------------------------------------------------------------------------------------------------
'-----[ Property Mail Receiver Address ]-------------------------------------------------------------
Public Property Get MailReceiverAddress() As String
    MailReceiverAddress = strMailReceiverAddress
End Property
Public Property Let MailReceiverAddress(strNewMailReceiverAddress As String)
    strMailReceiverAddress = strNewMailReceiverAddress
End Property
'----------------------------------------------------------------------------------------------------
'-----[ Property Mail CC ]---------------------------------------------------------------------------
Public Property Get MailCC() As String
    MailCC = strMailCC
End Property
Public Property Let MailCC(strNewMailCC As String)
    strMailCC = strNewMailCC
End Property
'----------------------------------------------------------------------------------------------------
'-----[ Property Mail BCC ]--------------------------------------------------------------------------
Public Property Get MailBCC() As String
    MailBCC = strMailBCC
End Property
Public Property Let MailBCC(strNewMailBCC As String)
    strMailBCC = strNewMailBCC
End Property
'----------------------------------------------------------------------------------------------------
'-----[ Property Mail Subject ]----------------------------------------------------------------------
Public Property Get MailSubject() As String
    MailSubject = strMailSubject
End Property
Public Property Let MailSubject(strNewMailSubject As String)
    strMailSubject = strNewMailSubject
End Property
'----------------------------------------------------------------------------------------------------
'-----[ Property Mail Message Text ]-----------------------------------------------------------------
Public Property Get MailMessageText() As String
    MailMessageText = strMailMessageText
End Property
Public Property Let MailMessageText(strNewMailMessageText As String)
    strMailMessageText = strNewMailMessageText
End Property
'----------------------------------------------------------------------------------------------------
'-----[ Property Mail Message HTML ]-----------------------------------------------------------------
Public Property Get MailMessageHTML() As String
    MailMessageHTML = strMailMessageHTML
End Property
Public Property Let MailMessageHTML(strNewMailMessageHTML As String)
    strMailMessageHTML = strNewMailMessageHTML
End Property
'----------------------------------------------------------------------------------------------------
'====================================================================================================


'####################################################################################################
'#####[ Class ]######################################################################################
'####################################################################################################
Private Sub Class_Initialize()
    Set sckPOP3 = New MSWinsockLib.Winsock
    Set sckSMTP = New MSWinsockLib.Winsock
    Set tmrTime = frmMain.Controls.Add("VB.Timer", "tmrTimeout")
    '
    tmrTime.Enabled = False
    tmrTime.Interval = 1000
End Sub

Private Sub Class_Terminate()
    Socket_Close sckPOP3
    Socket_Close sckSMTP
    '
    frmMain.Controls.Remove tmrTime.Name
    '
    Set tmrTime = Nothing
    Set sckPOP3 = Nothing
    Set sckSMTP = Nothing
End Sub

'####################################################################################################
'#####[ Methods  ]###################################################################################
'####################################################################################################
Public Function AddFile(strFilePath As String, Optional strDescription As String = "") As Boolean
    Dim blnReturn As Boolean
    '
    If File_Exist(strFilePath) = True Then
        lngMailAttachment = lngMailAttachment + 1
        ReDim Preserve objMailAttachment(1 To lngMailAttachment)
        With objMailAttachment(lngMailAttachment)
            .strPath = strFilePath
            .strDesc = strDescription
        End With
        blnReturn = True
    End If
    '
    AddFile = blnReturn
End Function

Public Function AddHeader(strKey As String, strVal As String) As Boolean
    Dim lngIndex As Long
    Dim i        As Long
    '
    If strKey <> "" Then
        If (InStr(strKey, vbCr) + _
            InStr(strKey, vbLf) + _
            InStr(strVal, vbCr) + _
            InStr(strVal, vbLf)) = 0 Then
            '
            For i = 1 To lngMailHeader
                If LCase(objMailHeader(i).strKey) = LCase(strKey) Then
                    lngIndex = i
                    Exit For
                End If
            Next i
            '
            If lngIndex < 1 Then
                lngMailHeader = lngMailHeader + 1
                ReDim Preserve objMailHeader(1 To lngMailHeader)
                lngIndex = lngMailHeader
            End If
            '
            With objMailHeader(lngIndex)
                .strKey = strKey
                .strVal = strVal
            End With
            '
            AddHeader = True
        Else
            AddHeader = False
        End If
    Else
        AddHeader = False
    End If
End Function

Public Sub Cancel(Optional blnForce As Boolean = False)
    If lngSendMailState >= stNothing Then
        If blnForce = True Then
            lngSendMailState = stCancel
            '
            Socket_Close sckPOP3
            Socket_Close sckSMTP
            '
            If intMailAttachment <> 0 Then
                Close #intMailAttachment
                intMailAttachment = 0
            End If
        Else
            '
            If sckPOP3.State = sckConnected Then
                lngSendMailState = stCancel
                SendData sckPOP3, "QUIT" & vbCrLf
                '
                blnServerDisconnect = True
                Do While blnServerDisconnect = True
                    DoEvents
                Loop
            End If
            '
            If sckSMTP.State = sckConnected Then
                lngSendMailState = stQuit
                SendData sckSMTP, "QUIT" & vbCrLf
                '
                blnServerDisconnect = True
                Do While blnServerDisconnect = True
                    DoEvents
                Loop
            End If
            '
            Socket_Close sckPOP3
            Socket_Close sckSMTP
        End If
        '
        RaiseEvent Error("Canceled from user")
    End If
End Sub

Public Function Reset()
    AccountUsername = ""
    AccountPassword = ""
    '
    Authentication = AUTH_CRAM_MD5
    MailMessageEncoding = smBase64
    MailFileEncoding = sfBase64
    MailHeaderEncoding = shBase64
    '
    ServerNamePOP3 = ""
    ServerPortPOP3 = 0
    '
    ServerNameSMTP = ""
    ServerPortSMTP = 0
    '
    Timeout = 60
    '
    MailFromName = ""
    MailFromAddress = ""
    MailReceiverName = ""
    MailReceiverAddress = ""
    MailCC = ""
    MailBCC = ""
    MailSubject = ""
    MailMessageText = ""
    MailMessageHTML = ""
    MailType = TextMail
    '
    Erase objMailReceiverCC()
    lngMailReceiverCC = 0
    '
    Erase objMailReceiverBCC()
    lngMailReceiverBCC = 0
    '
    Erase objMailHeader()
    lngMailHeader = 0
    '
    Erase objMailAttachment()
    lngMailAttachment = 0
    '
    If intMailAttachment <> 0 Then
        Close #intMailAttachment
        intMailAttachment = 0
    End If
    '
    sngSendFilePercent = 0
    lngSendFileIndex = 0
    lngSendFileCount = 0
    '
    strMailBoundary = ""
    '
    lngSendMailState = stNothing
    '
    dblByteLoad = 0
    dblByteSend = 0
    '
    dblLastData = 0
    '
    blnServerDisconnect = False
    '
    'default header
    AddHeader "Date", ""
    AddHeader "From", ""
    AddHeader "To", ""
    AddHeader "Subject", ""
    AddHeader "CC", ""
    AddHeader "BCC", ""
    AddHeader "Reply-To", ""
    AddHeader "Return-Path", ""
    AddHeader "X-Mailer", ""
    AddHeader "X-Sender-IP", ""
    AddHeader "MIME-Version", ""
    AddHeader "Content-Type", ""
    AddHeader "Content-Transfer-Encoding", ""
End Function

Public Function SendMail()
    objMailReceiverCC() = ReceiverListGet(strMailCC)
    lngMailReceiverCC = 0
    '
    objMailReceiverBCC() = ReceiverListGet(strMailBCC)
    lngMailReceiverBCC = 0
    '
    If Authentication = AUTH_POP3_BEFORE_SMTP Then
        Connect_POP3
    Else
        Connect_SMTP
    End If
End Function

'####################################################################################################
'#####[ POP3 Socket ]################################################################################
'####################################################################################################
Private Sub sckPOP3_Connect()
    If lngSendMailState <> stCancel Then
        lngSendMailState = stConnected
    End If
End Sub

Private Sub sckPOP3_Close()
    If blnServerDisconnect = True Then
        blnServerDisconnect = False
    Else
        If ((lngSendMailState >= stNothing) And (lngSendMailState <> stComplete)) Then
            RaiseEvent Error("Connection closed from server")
        End If
    End If
End Sub

Private Sub sckPOP3_Error(ByVal Number As Integer, Description As String, ByVal Scode As Long, ByVal Source As String, ByVal HelpFile As String, ByVal HelpContext As Long, CancelDisplay As Boolean)
    Socket_Close sckPOP3
    lngSendMailState = stError
    RaiseEvent Error("Socket Error " & CStr(Number) & ":" & vbCrLf & vbCrLf & Description)
End Sub

Private Sub sckPOP3_DataArrival(ByVal bytesTotal As Long)
    Dim strLine() As String
    Dim strTemp   As String
    Dim i         As Long
    '
    Static strData As String
    '
    'On Error Resume Next
    '
    sckPOP3.GetData strTemp, vbString
    dblByteLoad = dblByteLoad + bytesTotal
    dblLastData = CDbl(Now())
    '
    If lngSendMailState = stPopLogin Then
        strData = strData & strTemp
        If Right(strData, 5) = (vbCrLf & "." & vbCrLf) Then
            strTemp = strData
        Else
            Exit Sub
        End If
    End If
    strLine() = SplitResponse(strTemp)
    '
    For i = LBound(strLine()) To UBound(strLine())
        RaiseEvent LogData("Server", strLine(i))
    Next i
    '
    If UCase(Left(strLine(1), 3)) = "+OK" Then
        Select Case lngSendMailState
            '----------------------------------------------------------------------------------------
            Case Is = stConnected
                lngSendMailState = stUsername
                SendData sckPOP3, "USER " & AccountUsername & vbCrLf, True, True
    
            '----------------------------------------------------------------------------------------
            Case Is = stUsername
                lngSendMailState = stPassword
                SendData sckPOP3, "PASS " & AccountPassword & vbCrLf, True, True
    
            '----------------------------------------------------------------------------------------
            Case Is = stPassword
                lngSendMailState = stPopLogin
                SendData sckPOP3, "LIST" & vbCrLf, True, True

            '----------------------------------------------------------------------------------------
            Case Is = stPopLogin
                lngSendMailState = stQuit
                SendData sckPOP3, "QUIT" & vbCrLf, True, True
    
            '----------------------------------------------------------------------------------------
            Case Is = stQuit
                lngSendMailState = stDisconnected
                Socket_Close sckPOP3
                RaiseEvent LogData("Client", "[connection closed]" & vbCrLf & vbCrLf & String(76, "-") & vbCrLf)
                Connect_SMTP

            '----------------------------------------------------------------------------------------
            Case Is = stCancel
                lngSendMailState = stDisconnected

            '----------------------------------------------------------------------------------------
        End Select
    Else
        SendData sckPOP3, "QUIT" & vbCrLf, True, True
        Socket_Close sckPOP3
        RaiseEvent Error(strLine(1))
    End If
    '
End Sub

Private Sub sckPOP3_SendProgress(ByVal bytesSent As Long, ByVal bytesRemaining As Long)
    dblByteSend = dblByteSend + bytesSent
    dblLastData = CDbl(Now())
End Sub

'####################################################################################################
'#####[ ESMTP Socket ]###############################################################################
'####################################################################################################
Private Sub sckSMTP_Connect()
    If lngSendMailState <> stCancel Then
        lngSendMailState = stConnected
    End If
End Sub

Private Sub sckSMTP_Close()
    If blnServerDisconnect = True Then
        blnServerDisconnect = False
    Else
        If ((lngSendMailState >= stNothing) And (lngSendMailState <> stComplete)) Then
            RaiseEvent Error("Connection closed from server")
        End If
    End If
End Sub

Private Sub sckSMTP_Error(ByVal Number As Integer, Description As String, ByVal Scode As Long, ByVal Source As String, ByVal HelpFile As String, ByVal HelpContext As Long, CancelDisplay As Boolean)
    Socket_Close sckSMTP
    lngSendMailState = stError
    RaiseEvent Error("Socket Error " & CStr(Number) & ":" & vbCrLf & vbCrLf & Description)
End Sub

Private Sub sckSMTP_DataArrival(ByVal bytesTotal As Long)
    Dim strLine() As String
    Dim strTemp   As String
    Dim strData   As String
    Dim lngCode   As Long
    Dim lngChar   As Long
    Dim lngTemp   As Long
    Dim i         As Long
    Dim j         As Long
    Dim n         As Long
    Dim blnErr    As Boolean
    '
    'On Error Resume Next
    '
    If lngSendMailState = stCancel Then
        Exit Sub
    End If
    '
    sckSMTP.GetData strTemp, vbString
    dblByteLoad = dblByteLoad + bytesTotal
    dblLastData = CDbl(Now())
    '
    strLine() = SplitResponse(strTemp)
    strTemp = ""
    '
    For i = LBound(strLine()) To UBound(strLine())
        RaiseEvent LogData("Server", strLine(i))
    Next i
    '
    lngCode = CLng(Val(Left(strLine(1), 3)))
    '
    Select Case lngCode
        '--------------------------------------------------------------------------------------------
        Case Is = 220 'Service ready
            lngSendMailState = stEhlo
            SendData sckSMTP, "EHLO " & sckSMTP.LocalHostName & vbCrLf

        '--------------------------------------------------------------------------------------------
        Case Is = 221 'Service closing transmission channel
            lngSendMailState = stComplete
            Socket_Close sckSMTP
            RaiseEvent LogData("Client", "[connection closed]" & vbCrLf)
            RaiseEvent SendComplete
        '
        '--------------------------------------------------------------------------------------------
        Case Is = 235 'Authentication successfully completed, send MAIL FROM
            lngSendMailState = stMailFrom
            SendData sckSMTP, "MAIL FROM:<" & MailFromAddress & ">" & vbCrLf
        '
        '--------------------------------------------------------------------------------------------
        Case Is = 250 'Requested mail action okay, completed
            Select Case lngSendMailState
                '
                Case Is = stEhlo ' EHLO command successful: server support ESMTP
                    Select Case Authentication 'send authentication data to the server
                        '
                        Case Is = AUTH_POP3_BEFORE_SMTP 'we are already authenticated, send MAIL FROM
                            lngSendMailState = stMailFrom
                            SendData sckSMTP, "MAIL FROM:<" & MailFromAddress & ">" & vbCrLf

                        '
                        Case Is = AUTH_PLAIN 'use PLAIN authentication
                            lngSendMailState = stRequestAuthentication
                            SendData sckSMTP, "AUTH PLAIN" & vbCrLf

                        '
                        Case Is = AUTH_LOGIN 'use LOGIN authentication
                            lngSendMailState = stRequestAuthentication
                            SendData sckSMTP, "AUTH LOGIN" & vbCrLf

                        '
                        Case Else 'AUTH_CRAM_MD5 'use CRAM-MD5 authentication
                            lngSendMailState = stRequestAuthentication
                            SendData sckSMTP, "AUTH CRAM-MD5" & vbCrLf

                        '
                    End Select
                
                '
                Case Is = stMailFrom 'MAIL FROM command successful
                    lngSendMailState = stRcptTo
                    SendData sckSMTP, "RCPT TO:<" & MailReceiverAddress & ">" & vbCrLf
                
                '
                Case Is = stRcptTo 'RCPT TO command successful
                    If lngMailReceiverCC < UBound(objMailReceiverCC()) Then 'send to a cc receiver ?
                        lngMailReceiverCC = lngMailReceiverCC + 1
                        SendData sckSMTP, "RCPT TO:<" & objMailReceiverCC(lngMailReceiverCC).strAddr & ">" & vbCrLf
                    ElseIf lngMailReceiverBCC < UBound(objMailReceiverBCC()) Then 'send to a bcc receiver ?
                        lngMailReceiverBCC = lngMailReceiverBCC + 1
                        SendData sckSMTP, "RCPT TO:<" & objMailReceiverBCC(lngMailReceiverBCC).strAddr & ">" & vbCrLf
                    Else 'tell the server that the message data follows
                        lngSendMailState = stData
                        SendData sckSMTP, "DATA" & vbCrLf
                    End If

                '
                Case Is = stData 'message data successful sended
                    lngSendMailState = stQuit
                    SendData sckSMTP, "QUIT" & vbCrLf

                '
                Case Else 'anything goes wrong on the server ?!?!
                    RaiseEvent Error("Wrong server response:" & vbCrLf & vbCrLf & strLine(1))

                '
            End Select

        '--------------------------------------------------------------------------------------------
        Case Is = 251 'User not local; will forward to <forward-path>
            lngSendMailState = stData
            SendData sckSMTP, "DATA" & vbCrLf

        '--------------------------------------------------------------------------------------------
        Case Is = 334 'Server request authentication
            Select Case Authentication 'authenticate by selected mode
                '
                Case Is = AUTH_PLAIN
                    lngSendMailState = stPassword
                    SendData sckSMTP, Base64_Encode(vbNullChar & AccountUsername & vbNullChar & AccountPassword) & vbCrLf

                '
                Case Is = AUTH_LOGIN
                    If lngSendMailState = stRequestAuthentication Then 'if username not sended
                        lngSendMailState = stUsername
                        SendData sckSMTP, Base64_Encode(AccountUsername) & vbCrLf
                    Else 'if password not sended
                        lngSendMailState = stPassword
                        SendData sckSMTP, Base64_Encode(AccountPassword) & vbCrLf
                    End If

                '
                Case Is = AUTH_CRAM_MD5
                    lngSendMailState = stPassword
                    SendData sckSMTP, Base64_Encode(AccountUsername & " " & HMAC_MD5(AccountPassword, Base64_Decode(Trim(Mid(strLine(1), 4))))) & vbCrLf

                '
            End Select

        '--------------------------------------------------------------------------------------------
        Case Is = 354 'Start mail input; end with <CRLF>.<CRLF>
            RaiseEvent LogData("Client", "[message data]" & vbCrLf)
            '
            strMailBoundary = MakeBoundary 'create a boundary
            '
            'build the headers
            AddHeader "Date", DateToGMTString(Now())
            AddHeader "From", Header_String(MailFromName, MailHeaderEncoding) & " <" & MailFromAddress & ">"
            AddHeader "To", Header_String(MailReceiverName, MailHeaderEncoding) & " <" & MailReceiverAddress & ">"
            AddHeader "Subject", MailSubject
            AddHeader "Cc", ReceiverListSet(objMailReceiverCC(), MailHeaderEncoding)
            AddHeader "Bcc", ReceiverListSet(objMailReceiverBCC(), MailHeaderEncoding)
            AddHeader "Reply-To", Header_String(MailFromName, MailHeaderEncoding) & " <" & MailFromAddress & ">"
            AddHeader "Return-Path", Header_String(MailFromName, MailHeaderEncoding) & " <" & MailFromAddress & ">"
            AddHeader "X-Mailer", APPLICATION_NAME
            AddHeader "X-Sender-IP", sckSMTP.LocalIP
            AddHeader "MIME-Version", "1.0"
            AddHeader "Content-Type", "multipart/mixed; boundary=" & strMailBoundary
            '
            'build a header string
            strData = ""
            For n = 1 To lngMailHeader
                If objMailHeader(n).strVal <> "" Then
                    If LCase(objMailHeader(n).strKey) = "subject" Then
                        strData = strData & objMailHeader(n).strKey & ": " & Subject_Encode(objMailHeader(n).strVal, MailHeaderEncoding) & vbCrLf
                    Else
                        strData = strData & objMailHeader(n).strKey & ": " & objMailHeader(n).strVal & vbCrLf
                    End If
                End If
            Next n
            '
            'send the header string
            SendData sckSMTP, strData & vbCrLf, False, True
            '
            'send as textmail
            If ((MailType = TextMail) Or (MailType = Both)) Then
                'build sub header
                strData = ""
                strData = strData & "--" & strMailBoundary & vbCrLf
                If MailMessageEncoding = smUsAscii7Bit Then
                    strData = strData & "Content-Type: text/plain; charset=US-ASCII" & vbCrLf
                Else
                    strData = strData & "Content-Type: text/plain; charset=ISO-8859-1" & vbCrLf
                End If
                strData = strData & "Content-Transfer-Encoding: " & GetEncoding(MailMessageEncoding) & vbCrLf
                If MailMessageEncoding = smBinary Then
                    strData = strData & "Content-Length: " & CStr(Len(MailMessageText)) & vbCrLf
                End If
                strData = strData & "Content-Disposition: inline" & vbCrLf
                strData = strData & "Content-Description: Mail message body" & vbCrLf
                strData = strData & vbCrLf
                '
                'send sub header
                SendData sckSMTP, strData, False, True
                '
                Select Case MailMessageEncoding ' select encoding
                    '
                    Case Is = smBase64
                        strTemp = Base64_Encode(MailMessageText)
                        For n = 1 To Len(strTemp) Step 76
                            SendData sckSMTP, Mid(strTemp, n, 76) & vbCrLf, False, True
                        Next n
                        SendData sckSMTP, vbCrLf, False, True

                    '
                    Case Is = smUsAscii7Bit
                        SendData sckSMTP, Encode_7Or8Bit(MailMessageText, True) & vbCrLf, False, True

                    '
                    Case Is = smMime8Bit
                        SendData sckSMTP, Encode_7Or8Bit(MailMessageText, False) & vbCrLf, False, True

                    '
                    Case Is = smBinary
                        SendData sckSMTP, MailMessageText & vbCrLf, False, True

                    '
                    Case Is = smQuotedPrintable
                        SendData sckSMTP, QuotedPrintable_Encode(MailMessageText) & vbCrLf, False, True

                    '
                    Case Else
                        SendData sckSMTP, Encode_7Or8Bit(MailMessageText, True) & vbCrLf, False, True

                    '
                End Select
                '
            End If
            '
            'send as htmlmail
            If ((MailType = HTMLMail) Or (MailType = Both)) Then
                'build sub header
                strData = ""
                strData = strData & "--" & strMailBoundary & vbCrLf
                If MailMessageEncoding = smUsAscii7Bit Then
                    strData = strData & "Content-Type: text/html; charset=US-ASCII" & vbCrLf
                Else
                    strData = strData & "Content-Type: text/html; charset=ISO-8859-1" & vbCrLf
                End If
                strData = strData & "Content-Transfer-Encoding: " & GetEncoding(MailMessageEncoding) & vbCrLf
                If MailMessageEncoding = smBinary Then
                    strData = strData & "Content-Length: " & CStr(Len(MailMessageHTML)) & vbCrLf
                End If
                strData = strData & "Content-Disposition: inline" & vbCrLf
                strData = strData & "Content-Description: Mail message body" & vbCrLf
                strData = strData & vbCrLf
                '
                'send sub header
                SendData sckSMTP, strData, False, True
                '
                Select Case MailMessageEncoding ' select encoding
                    '
                    Case Is = smBase64
                        strTemp = Base64_Encode(MailMessageHTML)
                        For n = 1 To Len(strTemp) Step 76
                            SendData sckSMTP, Mid(strTemp, n, 76) & vbCrLf, False, True
                        Next n
                        SendData sckSMTP, vbCrLf, False, True

                    '
                    Case Is = smUsAscii7Bit
                        SendData sckSMTP, Encode_7Or8Bit(MailMessageHTML, True) & vbCrLf, False, True

                    '
                    Case Is = smMime8Bit
                        SendData sckSMTP, Encode_7Or8Bit(MailMessageHTML, False) & vbCrLf, False, True

                    '
                    Case Is = smBinary
                        SendData sckSMTP, MailMessageHTML & vbCrLf, False, True

                    '
                    Case Is = smQuotedPrintable
                        SendData sckSMTP, QuotedPrintable_Encode(MailMessageHTML) & vbCrLf & vbCrLf, False, True

                    '
                    Case Else
                        SendData sckSMTP, Encode_7Or8Bit(MailMessageHTML, True) & vbCrLf, False, True

                    '
                End Select
                '
            End If
            '
            '
            lngSendFileCount = lngMailAttachment
            '
            For n = 1 To lngMailAttachment 'attached files
                lngSendFileIndex = n
                '
                lngTemp = FileLen(objMailAttachment(n).strPath) 'filesize
                '
                'send sub header
                SendData sckSMTP, "--" & strMailBoundary & vbCrLf, False, True
                SendData sckSMTP, "Content-Type: application/octet-stream; name=""" & Mid(objMailAttachment(n).strPath, (InStrRev(objMailAttachment(n).strPath, "\") + 1)) & """" & vbCrLf, False, True
                SendData sckSMTP, "Content-Transfer-Encoding: " & GetEncoding(MailFileEncoding) & vbCrLf, False, True
                SendData sckSMTP, "Content-Disposition: attachment; filename=""" & Mid(objMailAttachment(n).strPath, (InStrRev(objMailAttachment(n).strPath, "\") + 1)) & """" & vbCrLf, False, True
                If objMailAttachment(n).strDesc <> "" Then
                    SendData sckSMTP, "Content-Description: " & objMailAttachment(n).strDesc & vbCrLf, False, True
                End If
                SendData sckSMTP, vbCrLf, False, True
                '
                'open the file
                intMailAttachment = FreeFile()
                Open objMailAttachment(n).strPath For Binary Access Read As #intMailAttachment
                    '
                    Select Case MailFileEncoding 'select encoding
                        '
                        Case Is = sfBase64
                            strData = ""
                            lngChar = 0
                            For j = 1 To (lngTemp - lngTemp Mod 3) Step 3 '"on-the-fly" base 64 encode :)
                                '
                                strTemp = Space$(3)
                                '
                                Get #intMailAttachment, j, strTemp
                                '
                                strData = strData & Mid(BASE64_TABLE, (Asc(Mid(strTemp, 1, 1)) \ 4) + 1, 1)
                                strData = strData & Mid(BASE64_TABLE, ((Asc(Mid(strTemp, 1, 1)) Mod 4) * 16 + Asc(Mid(strTemp, 1 + 1, 1)) \ 16) + 1, 1)
                                strData = strData & Mid(BASE64_TABLE, ((Asc(Mid(strTemp, 1 + 1, 1)) Mod 16) * 4 + Asc(Mid(strTemp, 1 + 2, 1)) \ 64) + 1, 1)
                                strData = strData & Mid(BASE64_TABLE, (Asc(Mid(strTemp, 1 + 2, 1)) Mod 64) + 1, 1)
                                lngChar = lngChar + 4
                                '
                                If lngChar = LNG_LINE_SIZE Then
                                    SendData sckSMTP, strData & vbCrLf, False, True
                                    strData = ""
                                    lngChar = 0
                                End If
                                '
                                sngSendFilePercent = ((j * 100) / lngTemp)
                                '
                                If lngSendMailState <> stData Then
                                    Exit Sub
                                End If
                                '
                            Next j
                            '
                            'base 64 padding
                            If Not (lngTemp Mod 3) = 0 Then
                                '
                                Get #intMailAttachment, j, strTemp
                                '
                                If (lngTemp Mod 3) = 2 Then
                                    strData = strData + Mid(BASE64_TABLE, (Asc(Mid(strTemp, 1, 1)) \ 4) + 1, 1)
                                    strData = strData + Mid(BASE64_TABLE, (Asc(Mid(strTemp, 1, 1)) Mod 4) * 16 + Asc(Mid(strTemp, 1 + 1, 1)) \ 16 + 1, 1)
                                    strData = strData + Mid(BASE64_TABLE, (Asc(Mid(strTemp, 1 + 1, 1)) Mod 16) * 4 + 1, 1)
                                    strData = strData & "="
                                ElseIf (lngTemp Mod 3) = 1 Then
                                    strData = strData + Mid(BASE64_TABLE, Asc(Mid(strTemp, 1, 1)) \ 4 + 1, 1)
                                    strData = strData + Mid(BASE64_TABLE, (Asc(Mid(strTemp, 1, 1)) Mod 4) * 16 + 1, 1)
                                    strData = strData & "=="
                                End If
                                lngChar = lngChar + 4
                            End If
                            '
                            If lngChar > 0 Then
                                SendData sckSMTP, strData & vbCrLf, False, True
                                strData = ""
                                lngChar = 0
                            End If
                            '

                        '
                        'Case Else 'other (user defined) encoding
                            'your "X-Encoding-Scheme"
    
                        '
                    End Select
                    '
                '
                Close #intMailAttachment
                intMailAttachment = 0
                SendData sckSMTP, vbCrLf, False, True
                '
                sngSendFilePercent = 100
                'file ready
            Next n 'next file
            '
            '
            SendData sckSMTP, "--" & strMailBoundary & "--" & vbCrLf, False, True
            SendData sckSMTP, vbCrLf & "." & vbCrLf, False, True
            'message data ready
            '

        '--------------------------------------------------------------------------------------------
        Case Else 'a non successful return
            blnErr = ((lngCode = 0) Or (lngCode >= 400)) 'no return or error code

        '--------------------------------------------------------------------------------------------
    End Select
    '
    If blnErr = True Then 'error ?
        Socket_Close sckSMTP
        RaiseEvent Error(strLine(1))
    End If
    '
    Erase strLine()
End Sub

Private Sub sckSMTP_SendProgress(ByVal bytesSent As Long, ByVal bytesRemaining As Long)
    dblByteSend = dblByteSend + bytesSent
    dblLastData = CDbl(Now())
End Sub

'####################################################################################################
'#####[ Timer ]######################################################################################
'####################################################################################################
Private Sub tmrTime_Timer()
    Dim dblNow As Double
    Dim lngTmp As Long
    '
    If lngSendFileIndex > 0 Then
        RaiseEvent SendFileProgress(sngSendFilePercent, lngSendFileIndex, lngSendFileCount)
    End If
    '
    dblNow = CDbl(Now())
    '
    lngTmp = DateDiff("s", dblLastData, dblNow)
    '
    If lngTmp < 0 Then
        lngTmp = 0
    End If
    '
    If lngTmp > Timeout Then
        lngTmp = Timeout
        '
        Socket_Close sckSMTP
        lngSendMailState = stTimeout
        RaiseEvent Error("Connection timeout")
    End If
    '
End Sub

'####################################################################################################
'#####[ Helper ]#####################################################################################
'####################################################################################################
Private Sub Connect_POP3()
    dblByteLoad = 0
    dblByteSend = 0
    lngSendMailState = stDisconnected
    dblLastData = CDbl(Now())
    tmrTime.Enabled = True
    sckPOP3.Connect ServerNamePOP3, ServerPortPOP3
End Sub

Private Sub Connect_SMTP()
    dblByteLoad = 0
    dblByteSend = 0
    lngSendMailState = stDisconnected
    dblLastData = CDbl(Now())
    tmrTime.Enabled = True
    sckSMTP.Connect ServerNameSMTP, ServerPortSMTP
End Sub

Private Function File_Exist(strFilePath As String) As Boolean
    Dim lngAttr As Long
    Dim blnRtrn As Boolean
    '
    If strFilePath <> "" Then
        lngAttr = GetFileAttributes(ByVal strFilePath)
        If lngAttr <> INVALID_HANDLE_VALUE Then
            blnRtrn = ((lngAttr And FILE_ATTRIBUTE_DIRECTORY) <> FILE_ATTRIBUTE_DIRECTORY)
        End If
    End If
    '
    File_Exist = blnRtrn
End Function

Private Function GetEncoding(lngEncType As Long) As String
    Select Case lngEncType
        Case Is = LNG_ENCODING_7BIT:                GetEncoding = "7Bit"
        Case Is = LNG_ENCODING_QUOTED_PRINTABLE:    GetEncoding = "Quoted-Printable"
        Case Is = LNG_ENCODING_BASE64:              GetEncoding = "Base64"
        Case Is = LNG_ENCODING_8BIT:                GetEncoding = "8Bit"
        Case Is = LNG_ENCODING_BINARY:              GetEncoding = "Binary"
        Case Else:                                  GetEncoding = "7Bit"
    End Select
End Function

Private Function MakeBoundary() As String
    Dim strBoundary     As String
    Dim strTemp(1 To 5) As String
    Dim i               As Long
    Dim bytTemp         As Byte
    '
    Const LNG_MIN As Long = &H0&
    Const LNG_MAX As Long = &HFF&
    '
    For i = LBound(strTemp()) To UBound(strTemp())
        bytTemp = CByte(Int((LNG_MAX - LNG_MIN + 1) * Rnd + LNG_MIN))
        If bytTemp < &H10 Then
            strTemp(i) = "0" & Hex(bytTemp)
        Else
            strTemp(i) = Hex(bytTemp)
        End If
    Next i
    '
    strBoundary = String(27, Chr$(&H2D)) & LCase(Join(strTemp(), vbNullString))
    '
    MakeBoundary = strBoundary
End Function

Private Function SendData(sckSocket As MSWinsockLib.Winsock, strData As String, Optional blnLog As Boolean = True, Optional blnWait As Boolean = True) 'As xxx
    Dim lngLen As Long
    Dim lngPos As Long
    '
    lngLen = Len(strData)
    lngPos = dblByteSend
    '
    If blnLog = True Then
        RaiseEvent LogData("Client", strData)
    End If
    '
    sckSocket.SendData strData
    '
    If blnWait = True Then
        Do While ((dblByteSend < (lngPos + lngLen)) And (lngSendMailState <> stCancel))
            DoEvents
        Loop
    End If
    '
End Function

Private Function SplitResponse(strData As String) As String()
    Dim strLine() As String
    Dim strTemp() As String
    Dim i         As Long
    Dim n         As Long
    '
    strTemp() = Split(Replace(strData, vbLf, ""), vbCr)
    '
    For i = LBound(strTemp()) To UBound(strTemp())
        If strTemp(i) <> "" Then
            n = n + 1
            ReDim Preserve strLine(1 To n)
            strLine(n) = strTemp(i)
        End If
    Next i
    '
    SplitResponse = strLine()
End Function

Private Function Socket_Close(sckSocket As MSWinsockLib.Winsock) As Boolean
    Dim blnReturn As Boolean
    '
    tmrTime.Enabled = False
    '
    If sckSocket.State = sckClosed Then
        blnReturn = True
    Else
        sckSocket.Close
        Do While (sckSocket.State <> sckClosed)
            DoEvents
        Loop
        blnReturn = (sckSocket.State = sckClosed)
    End If
    '
    Socket_Close = blnReturn
End Function
Private Function DateToGMTString(datDate As Date) As String
    Dim strGMT As String
    Dim tzi As TIME_ZONE_INFORMATION
    Dim lResult As Long
    Dim lBias As Long
    '
    lResult = GetTimeZoneInformation(tzi)
    If lResult <> TIME_ZONE_ID_INVALID Then
        lBias = tzi.Bias * -1
    End If
    '
    Select Case Weekday(datDate)
        Case 1:     strGMT = "Sun, "
        Case 2:     strGMT = "Mon, "
        Case 3:     strGMT = "Tue, "
        Case 4:     strGMT = "Wed, "
        Case 5:     strGMT = "Thu, "
        Case 6:     strGMT = "Fri, "
        Case Else:  strGMT = "Sat, "
    End Select
    '
    strGMT = strGMT & CStr(Day(datDate)) & " "
    '
    Select Case Month(datDate)
        Case 1:     strGMT = strGMT & "Jan "
        Case 2:     strGMT = strGMT & "Feb "
        Case 3:     strGMT = strGMT & "Mar "
        Case 4:     strGMT = strGMT & "Apr "
        Case 5:     strGMT = strGMT & "Mai "
        Case 6:     strGMT = strGMT & "Jun "
        Case 7:     strGMT = strGMT & "Jul "
        Case 8:     strGMT = strGMT & "Aug "
        Case 9:     strGMT = strGMT & "Sep "
        Case 10:    strGMT = strGMT & "Oct "
        Case 11:    strGMT = strGMT & "Nov "
        Case Else:  strGMT = strGMT & "Dec "
    End Select
    '
    strGMT = strGMT & CStr(Year(datDate)) & " "
    '
    strGMT = strGMT & Format(Hour(datDate), "00") & ":"
    strGMT = strGMT & Format(Minute(datDate), "00") & ":"
    strGMT = strGMT & Format(Second(datDate), "00") & " "
    strGMT = strGMT & IIf((lBias >= 0), "+", "-")
    strGMT = strGMT & Format(Abs(lBias \ 60), "00")
    strGMT = strGMT & Format(Abs(lBias Mod 60), "00")
    '
    DateToGMTString = strGMT
End Function

'####################################################################################################
'#####[ CC/BCC ]#####################################################################################
'####################################################################################################
Private Function ReceiverListGet(strData As String) As MAIL_RECEIVER()
    Dim objList() As MAIL_RECEIVER
    Dim strName   As String
    Dim strAddr   As String
    Dim strChar   As String
    Dim lngList   As Long
    Dim lngLen    As Long
    Dim i         As Long
    Dim blnName   As Boolean
    Dim blnAddr   As Boolean
    Dim blnNext   As Boolean
    Dim blnEscp   As Boolean
    '
    Const vbQuot As String * 1 = """"
    '
    lngLen = Len(strData)
    '
    For i = 1 To lngLen
        strChar = Mid(strData, i, 1)
        '
        If ((strChar = vbQuot) And (blnName = False) And (blnAddr = False)) Then
            blnName = True
            strChar = ""
        ElseIf ((strChar = "\") And (blnName = True) And (blnAddr = False)) Then
            If blnEscp = True Then
                blnEscp = False
            Else
                blnEscp = True
                strChar = ""
            End If
        ElseIf ((strChar = vbQuot) And (blnName = True) And (blnAddr = False)) Then
            If blnEscp = True Then
                blnEscp = False
            Else
                blnName = False
                strChar = ""
            End If
        ElseIf ((strChar = "<") And (blnName = False) And (blnAddr = False)) Then
            blnAddr = True
            strChar = ""
        ElseIf ((strChar = ">") And (blnName = False) And (blnAddr = True)) Then
            blnAddr = False
            strChar = ""
        ElseIf ((strChar = ",") And (blnName = False) And (blnAddr = False)) Then
            blnNext = True
            strChar = ""
        End If
        '
        If blnName = True Then
            strName = strName & strChar
        End If
        '
        If blnAddr = True Then
            strAddr = strAddr & strChar
        End If
        '
        If ((blnNext = True) Or (i = lngLen)) Then
            lngList = lngList + 1
            ReDim Preserve objList(1 To lngList)
            objList(lngList).strName = strName
            objList(lngList).strAddr = strAddr
            strName = ""
            strAddr = ""
            blnNext = False
        End If
    Next i
    '
    If lngList < 1 Then
        ReDim objList(0 To 0)
    End If
    '
    ReceiverListGet = objList()
End Function

Private Function ReceiverListSet(objList() As MAIL_RECEIVER, lngEncType As SMTP_HEADER_ENCODING) As String
    Dim strData  As String
    Dim lngCount As Long
    Dim i        As Long
    '
    lngCount = UBound(objList())
    '
    For i = 1 To lngCount
        If objList(i).strName = "" Then
            strData = strData & "<" & objList(i).strAddr & ">"
        Else
            Select Case lngEncType
                Case Is = shBase64:             strData = strData & "=?ISO-8859-1?B?" & Base64_Encode(objList(i).strName) & "?= <" & objList(i).strAddr & ">"
                Case Is = shQuotedPrintable:    strData = strData & "=?ISO-8859-1?Q?" & QuotedPrintable_String(objList(i).strName) & "?= <" & objList(i).strAddr & ">"
                Case Else:                      strData = strData & objList(i).strName & " <" & objList(i).strAddr & ">"
            End Select
        End If
        '
        If i < lngCount Then
            strData = strData & ", "
        End If
    Next i
    '
    ReceiverListSet = strData
End Function

'####################################################################################################
'#####[ MD5 ]########################################################################################
'####################################################################################################
Private Function MD5(Key As String) As String
    Dim strHash           As String
    Dim lngResult         As Long
    Dim lngHHash          As Long
    Dim lngHCryptProvider As Long
    Dim lngHashLength     As Long
    Dim i                 As Long
    Dim abytBuffer()      As Byte
    '
    Const cstBufferSize As Long = 256
    '
    ReDim abytBuffer(0 To cstBufferSize)
    '
    lngResult = CryptAcquireContext(lngHCryptProvider, vbNullString, MS_ENHANCED_PROV, PROV_RSA_FULL, CRYPT_VERIFYCONTEXT)
    If lngResult = 1 Then
        lngResult = CryptCreateHash(lngHCryptProvider, CALG_MD5, 0, 0, lngHHash)
        If lngResult = 1 Then
            lngResult = CryptHashData(lngHHash, Key, Len(Key), 0)
            If lngResult = 1 Then
                lngResult = CryptGetHashParam(lngHHash, HP_HASHSIZE, abytBuffer(0), cstBufferSize, 0)
                If lngResult = 1 Then
                    lngHashLength = abytBuffer(0)
                    lngResult = CryptGetHashParam(lngHHash, HP_HASHVAL, abytBuffer(0), cstBufferSize, 0)
                    If lngResult = 1 Then
                        For i = 0 To (lngHashLength - 1)
                            If abytBuffer(i) < 16 Then
                                strHash = strHash & "0"
                            End If
                            strHash = strHash & LCase(Hex(abytBuffer(i)))
                        Next i
                    End If
                End If
            End If
        End If
    End If
    '
    MD5 = strHash
End Function

'####################################################################################################
'#####[ HMAC MD5 ]###################################################################################
'####################################################################################################
Private Function HMAC_MD5(Key As String, Data As String) As String
    Dim iPad As String
    Dim oPad As String
    '
    Const MD5_BLOCK_LEN As Long = &H40&
    '
    If Len(Key) > MD5_BLOCK_LEN Then
        Key = Pack(MD5(Key))
    End If
    '
    Key = Key & String((MD5_BLOCK_LEN - Len(Key)), vbNullChar)
    '
    iPad = String(MD5_BLOCK_LEN, Chr$(&H36))
    oPad = String(MD5_BLOCK_LEN, Chr$(&H5C))
    '
    iPad = StrXor(Key, iPad)
    oPad = StrXor(Key, oPad)
    '
    HMAC_MD5 = MD5(oPad & Pack(MD5(iPad & Data)))
End Function

Private Function StrXor(Expression1 As String, Expression2 As String) As String
    Dim strReturn        As String
    Dim i                As Long
    Dim bytReturn()      As Byte
    Dim bytExpression1() As Byte
    Dim bytExpression2() As Byte
    '
    If Len(Expression1) = Len(Expression2) Then
        bytExpression1() = StrConv(Expression1, vbFromUnicode)
        bytExpression2() = StrConv(Expression2, vbFromUnicode)
        '
        ReDim bytReturn(LBound(bytExpression1()) To UBound(bytExpression1()))
        '
        For i = LBound(bytExpression1()) To UBound(bytExpression1())
            bytReturn(i) = bytExpression1(i) Xor bytExpression2(i)
        Next i
        '
        strReturn = StrConv(bytReturn(), vbUnicode)
    End If
    '
    StrXor = strReturn
End Function

Private Function Pack(strData As String) As String
    Dim strPack As String
    Dim lngLen  As Long
    Dim lngPos  As Long
    '
    lngLen = Len(strData)
    lngPos = 1
    '
    Do While (lngPos < lngLen)
        strPack = strPack & Chr$(Val("&H" & Mid(strData, lngPos, 2)))
        lngPos = lngPos + 2
    Loop
    '
    Pack = strPack
End Function

'####################################################################################################
'#####[ Base64 ]#####################################################################################
'####################################################################################################
Private Function Base64_Encode(strSource As String) As String
    Dim strTempLine As String
    Dim j As Integer
    '
    For j = 1 To (Len(strSource) - Len(strSource) Mod 3) Step 3
        strTempLine = strTempLine + Mid(BASE64_TABLE, (Asc(Mid(strSource, j, 1)) \ 4) + 1, 1)
        strTempLine = strTempLine + Mid(BASE64_TABLE, ((Asc(Mid(strSource, j, 1)) Mod 4) * 16 + Asc(Mid(strSource, j + 1, 1)) \ 16) + 1, 1)
        strTempLine = strTempLine + Mid(BASE64_TABLE, ((Asc(Mid(strSource, j + 1, 1)) Mod 16) * 4 + Asc(Mid(strSource, j + 2, 1)) \ 64) + 1, 1)
        strTempLine = strTempLine + Mid(BASE64_TABLE, (Asc(Mid(strSource, j + 2, 1)) Mod 64) + 1, 1)
    Next j
    '
    If Not (Len(strSource) Mod 3) = 0 Then
        If (Len(strSource) Mod 3) = 2 Then
            strTempLine = strTempLine + Mid(BASE64_TABLE, (Asc(Mid(strSource, j, 1)) \ 4) + 1, 1)
            strTempLine = strTempLine + Mid(BASE64_TABLE, (Asc(Mid(strSource, j, 1)) Mod 4) * 16 + Asc(Mid(strSource, j + 1, 1)) \ 16 + 1, 1)
            strTempLine = strTempLine + Mid(BASE64_TABLE, (Asc(Mid(strSource, j + 1, 1)) Mod 16) * 4 + 1, 1)
            strTempLine = strTempLine & "="
        ElseIf (Len(strSource) Mod 3) = 1 Then
            strTempLine = strTempLine + Mid(BASE64_TABLE, Asc(Mid(strSource, j, 1)) \ 4 + 1, 1)
            strTempLine = strTempLine + Mid(BASE64_TABLE, (Asc(Mid(strSource, j, 1)) Mod 4) * 16 + 1, 1)
            strTempLine = strTempLine & "=="
        End If
    End If
    Base64_Encode = strTempLine
End Function

Private Function Base64_Decode(a As String) As String
    Dim w1 As Integer
    Dim w2 As Integer
    Dim w3 As Integer
    Dim w4 As Integer
    Dim n As Integer
    Dim retry As String
    '
    For n = 1 To Len(a) Step 4
        w1 = MimeDecode(Mid$(a, n, 1))
        w2 = MimeDecode(Mid$(a, n + 1, 1))
        w3 = MimeDecode(Mid$(a, n + 2, 1))
        w4 = MimeDecode(Mid$(a, n + 3, 1))
        '
        If w2 >= 0 Then
            retry = retry + Chr$(((w1 * 4 + Int(w2 / 16)) And 255))
        End If
        '
        If w3 >= 0 Then
            retry = retry + Chr$(((w2 * 16 + Int(w3 / 4)) And 255))
        End If
        '
        If w4 >= 0 Then
            retry = retry + Chr$(((w3 * 64 + w4) And 255))
        End If
    Next
    '
    Base64_Decode = retry
End Function

Private Function MimeDecode(a As String) As Integer
    If Len(a) = 0 Then
        MimeDecode = -1
        Exit Function
    End If
    '
    MimeDecode = InStr(BASE64_TABLE, a) - 1
End Function

'####################################################################################################
'#####[ 7-Bit / 8-Bit Encoding ]#####################################################################
'####################################################################################################
Private Function Encode_7Or8Bit(strData As String, bln7Bit As Boolean) As String
    Dim strLine() As String
    Dim strTemp() As String
    Dim str7Bit   As String
    Dim lngTemp   As Long
    Dim i         As Long
    Dim n         As Long
    Dim bytChar   As Byte
    '
    strLine() = Split(strData, vbCrLf)
    '
    For i = LBound(strLine()) To UBound(strLine())
        '
        ReDim Preserve strTemp(0 To lngTemp)
        '
        If bln7Bit = True Then
            str7Bit = ""
            For n = 1 To Len(strLine(i))
                bytChar = CByte(Asc(Mid(strLine(i), n, 1)))
                If ((bytChar >= 1) And (bytChar <= 127)) Then
                    str7Bit = str7Bit & Chr$(bytChar)
                End If
            Next n
            strLine(i) = str7Bit
        End If
        '
        Do While Len(strLine(i)) > 998
            strTemp(lngTemp) = Left(strLine(i), 998)
            strLine(i) = Mid(strLine(i), 999)
            lngTemp = lngTemp + 1
            ReDim Preserve strTemp(0 To lngTemp)
        Loop
        '
        strTemp(lngTemp) = strLine(i)
        lngTemp = lngTemp + 1
        '
    Next i
    '
    Encode_7Or8Bit = Join(strTemp(), vbCrLf)
End Function

'####################################################################################################
'#####[ Quoted-Printable Encoding ]##################################################################
'####################################################################################################
Private Function QuotedPrintable_Encode(strData As String) As String
    Dim strLine() As String
    Dim strTemp() As String
    Dim strCode   As String
    Dim strChar   As String * 1
    Dim lngChar   As Long
    Dim lngTemp   As Long
    Dim lngLen    As Long
    Dim lngPos    As Long
    Dim i         As Long
    Dim bytChar   As Byte
    '
    If strData <> "" Then
        strLine() = Split(strData, vbCrLf)
        For i = LBound(strLine()) To UBound(strLine())
            ReDim Preserve strTemp(0 To lngTemp)
            lngPos = 1
            lngLen = Len(strLine(i))
            lngChar = 0
            Do While (lngPos <= lngLen)
                If ((lngChar = 75) And (lngLen > 76)) Then
                    strTemp(lngTemp) = strTemp(lngTemp) & "="
                    lngTemp = lngTemp + 1
                    ReDim Preserve strTemp(0 To lngTemp)
                    lngChar = 0
                End If
                strChar = Mid(strLine(i), lngPos, 1)
                bytChar = CByte(Asc(strChar))
                If (((bytChar >= 33) And (bytChar <= 60)) Or _
                    ((bytChar >= 62) And (bytChar <= 126))) Then
                    strTemp(lngTemp) = strTemp(lngTemp) & strChar
                    lngChar = lngChar + 1
                    lngPos = lngPos + 1
                ElseIf ((bytChar = 9) Or (bytChar = 32)) Then
                    If lngPos < lngLen Then
                        strTemp(lngTemp) = strTemp(lngTemp) & strChar
                        lngChar = lngChar + 1
                        lngPos = lngPos + 1
                    Else
                        If lngChar < 73 Then
                            If bytChar < 16 Then
                                strTemp(lngTemp) = strTemp(lngTemp) & "=0" & Hex(bytChar)
                            Else
                                strTemp(lngTemp) = strTemp(lngTemp) & "=" & Hex(bytChar)
                            End If
                            lngChar = lngChar + 3
                            lngPos = lngPos + 1
                        Else
                            strTemp(lngTemp) = strTemp(lngTemp) & "="
                            lngTemp = lngTemp + 1
                            ReDim Preserve strTemp(0 To lngTemp)
                            lngChar = 0
                        End If
                    End If
                Else
                    If lngChar < 73 Then
                        If bytChar < 16 Then
                            strTemp(lngTemp) = strTemp(lngTemp) & "=0" & Hex(bytChar)
                        Else
                            strTemp(lngTemp) = strTemp(lngTemp) & "=" & Hex(bytChar)
                        End If
                        lngChar = lngChar + 3
                        lngPos = lngPos + 1
                    Else
                        strTemp(lngTemp) = strTemp(lngTemp) & "="
                        lngTemp = lngTemp + 1
                        ReDim Preserve strTemp(0 To lngTemp)
                        lngChar = 0
                    End If
                End If
            Loop
            lngTemp = lngTemp + 1
        Next i
        strCode = Join(strTemp(), vbCrLf)
    End If
    '
    QuotedPrintable_Encode = strCode
End Function

Private Function QuotedPrintable_String(strData As String) As String
    Dim strCode As String
    Dim lngLen  As Long
    Dim i       As Long
    Dim bytChar As Byte
    '
    lngLen = Len(strData)
    '
    For i = 1 To lngLen
        bytChar = CByte(Asc(Mid(strData, i, 1)))
        If (((bytChar >= 33) And (bytChar <= 60)) Or _
            ((bytChar >= 62) And (bytChar <= 126)) Or _
            ((bytChar = 32) And (i < lngLen)) Or _
            ((bytChar = 9) And (i < lngLen))) Then
            strCode = strCode & Chr$(bytChar)
        Else
            If bytChar < 16 Then
                strCode = strCode & "=0" & Hex(bytChar)
            Else
                strCode = strCode & "=" & Hex(bytChar)
            End If
        End If
    Next i
    '
    QuotedPrintable_String = strCode
End Function

'####################################################################################################
'#####[ Header Encoding ]############################################################################
'####################################################################################################
Private Function Header_String(strData As String, lngEncType As SMTP_HEADER_ENCODING) As String
    Dim strCode As String
    '
    Select Case lngEncType
        Case Is = shBase64:             strCode = "=?ISO-8859-1?B?" & Base64_Encode(strData) & "?="
        Case Is = shQuotedPrintable:    strCode = "=?ISO-8859-1?Q?" & QuotedPrintable_String(strData) & "?="
        Case Else:                      strCode = strData
    End Select
    '
    Header_String = strCode
End Function

'####################################################################################################
'#####[ Subject Encoding ]###########################################################################
'####################################################################################################
Private Function Subject_Encode(strData As String, lngEncType As SMTP_HEADER_ENCODING) As String
    Dim strCode As String
    Dim strTemp As String '18 76
    Dim lngChar As Long
    Dim lngLen  As Long
    Dim lngPos  As Long
    Dim bytChar As Byte
    '
    Select Case lngEncType
        '--------------------------------------------------------------------------------------------
        Case Is = shBase64
            strTemp = Base64_Encode(strData)
            Do While Len(strTemp) > 58
                If strCode <> "" Then
                    strCode = strCode & " "
                End If
                strCode = strCode & "=?ISO-8859-1?B?" & Left(strTemp, 58) & "?="
                strTemp = Mid(strTemp, 59)
                If strTemp <> "" Then
                    strCode = strCode & vbCrLf
                End If
            Loop
            If strTemp <> "" Then
                If strCode <> "" Then
                    strCode = strCode & " "
                End If
                strCode = strCode & "=?ISO-8859-1?B?" & strTemp & "?="
            End If
        '--------------------------------------------------------------------------------------------
        Case Is = shQuotedPrintable
            lngPos = 1
            lngLen = Len(strData)
            '
            strCode = "=?ISO-8859-1?Q?"
            '
            Do While lngPos <= lngLen
                bytChar = CByte(Asc(Mid(strData, lngPos, 1)))
                If (((bytChar >= 33) And (bytChar <= 60)) Or _
                    ((bytChar >= 62) And (bytChar <= 126)) Or _
                    ((bytChar = 32) And (lngPos < lngLen)) Or _
                    ((bytChar = 9) And (lngPos < lngLen))) Then
                    If lngChar < 58 Then
                        strCode = strCode & Chr$(bytChar)
                        lngChar = lngChar + 1
                        lngPos = lngPos + 1
                    Else
                        strCode = strCode & "?="
                        If lngPos < lngLen Then
                            strCode = strCode & vbCrLf & " =?ISO-8859-1?Q?"
                        End If
                        lngChar = 0
                    End If
                Else
                    If lngChar < 56 Then
                        If bytChar < 16 Then
                            strCode = strCode & "=0" & Hex(bytChar)
                        Else
                            strCode = strCode & "=" & Hex(bytChar)
                        End If
                        lngChar = lngChar + 3
                        lngPos = lngPos + 1
                    Else
                        strCode = strCode & "?="
                        If lngPos < lngLen Then
                            strCode = strCode & vbCrLf & " =?ISO-8859-1?Q?"
                        End If
                        lngChar = 0
                    End If
                End If
            Loop
            strCode = strCode & "?="
        '--------------------------------------------------------------------------------------------
        Case Else
            strCode = strData
        '--------------------------------------------------------------------------------------------
    End Select
    '
    Subject_Encode = strCode
End Function
